#!/usr/bin/perl
use strict;
use Search::OpenFTS;
use DBI();

print "Content-Type: text/html\n\n";

my $db = 'www:a'; # database:prefix

my $tid;
if ( $ENV{'QUERY_STRING'} =~ /tid=(\d+)/ ) {
  $tid = $1;
}

my ( $dbname, $PREFIX ) = '';
( $dbname, $PREFIX ) = split(':',$db);

my ( $dbh, $fts, $errstr );
$dbh = DBI->connect('DBI:Pg:dbname='.$dbname);
if ( ! $dbh ) {
  $errstr =  "Couldn't connect to database \'$dbname\' !<BR>";
  goto END;
}
$fts = Search::OpenFTS->new( $dbh, prefix=>$PREFIX);
if ( ! $fts ) {
  $errstr =  "Couldn't initialized fts object !<BR>";
  goto END;
}

my $sql = "select title,path,body, di, dlm from $fts->{TABLE} where  $fts->{TXTID} = $tid";

my $r = $dbh->selectrow_hashref($sql);
if ( $dbh->errstr ) {
  $errstr = "Problem with fetching cached document \'$tid\' from database !<BR>";
  $errstr .= $dbh->errstr;
  goto END;
}
my $path = $r->{path};
my $title = $r->{title};
$title ||= $path;
my $body = $r->{body};
my $di = $r->{di};
$di = localtime($di);
my $dlm = $r->{dlm};
$dlm = localtime($dlm);

print<<HEADER;
<html>
<head><title>$title</title>
<base href="$path">
</head>
<body>
<table bgcolor="orange" width="100%" border=1>
<tr><td><small>This is a cached document. Original URL: $path
<BR>
Indexed: $di
<BR>
Last modified: $dlm
</small>
</td></tr></table>
HEADER


print "$body\n";

END:

print $errstr if $errstr;

print<<FOOTER;
<div align="center">
<hr>
<small>
Powered by <a href="http://openfts.sourceforge.net">OpenFTS</a>&nbsp;v. $fts->{VERSION}</div>
</small>
</body>
</html>
FOOTER

$dbh->disconnect if $dbh;
